// command functions for butt
//
// Copyright 2007-2020 by Daniel Noethen.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include <stdio.h>
#include <string.h>
#include <pthread.h>

#ifdef WIN32
 #include <winsock2.h>
 #ifndef errno 
  #define errno WSAGetLastError() 
 #endif
 #ifndef EWOULDBLOCK
  #define EWOULDBLOCK WSAEWOULDBLOCK
 #endif
#else
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <unistd.h>
 #include <netinet/in.h> //defines IPPROTO_TCP on BSD
 #include <netdb.h>
 #include <sys/select.h>
 #include <errno.h>
#endif

#ifdef WIN32
 typedef int socklen_t;
#endif

#include "command.h"
#include "sockfuncs.h"

int server_cmd = CMD_EMPTY;
int port = 1256;


pthread_t listen_thread;
int listen_sock;

void *listen_thread_func(void *data)
{
    int conn_sock; 
    int cmd;
    int bytes_count;
    struct sockaddr_in cli; 
    socklen_t len; 
    len = sizeof(cli); 
  
    for (;;) {
        conn_sock = accept(listen_sock, (struct sockaddr*)&cli, &len); 
        bytes_count = recv(conn_sock, (char*)&cmd, sizeof(cmd), 0);
        if (bytes_count > 0)
            command_set_new_cmd(cmd);
    }

    return NULL;
}

int command_start_server(void)
{

#ifdef WIN32
    WSADATA wsa;
    WSAStartup(MAKEWORD(2,2),&wsa);
#endif

    int conn_sock; 
    struct sockaddr_in servaddr; 
  
    listen_sock = socket(AF_INET, SOCK_STREAM, 0); 
    if(listen_sock == -1)
          return SOCK_ERR_CREATE;
    memset(&servaddr, 0, sizeof(servaddr)); 
  
    servaddr.sin_family = AF_INET; 
    servaddr.sin_addr.s_addr = htonl(INADDR_LOOPBACK); 
    servaddr.sin_port = htons(port); 
  
    if (bind(listen_sock, (struct sockaddr*)&servaddr, sizeof(servaddr)) != 0) 
          return SOCK_ERR_BIND;

    if ((listen(listen_sock, 1)) != 0) 
          return SOCK_ERR_LISTEN;

    pthread_create(&listen_thread, NULL, listen_thread_func, NULL);

    return 0;
}


int command_send_cmd(int cmd)
{
    int s;
    s = sock_connect("127.0.0.1", port, 100);
    if (s < 0)
        return s;

    sock_send(&s, (char*)&cmd, sizeof(cmd), 100);
    sock_close(&s);

    return 0;
}

int command_get_last_cmd(void)
{
    int cmd = server_cmd;
    server_cmd = CMD_EMPTY;

    return cmd;
}

void command_set_new_cmd(int cmd)
{
    server_cmd = cmd;
}
